unit BMGSpriteCollection;

interface
uses windows,KOL,BMaxGTypes;

type TSRCObtacle=record
   width,height:word;
   PassMask:array of array of byte;
   itemcount:integer;
   items:array of TBitmaps;
   itemPos:array of TXY;
end;
type TSRCBitmap=record
   kind:byte;
   pass:byte;

   Bitmap:TBitmaps;
   colID:array of byte;
   colQty:array of word;
   colcount:integer;
end;
type TBMGSpriteCollection=class
   filename:string;
   name:string;
   LandItems:array of TSRCBitmap;
   LandItemsCount:integer;
   WaterItems:array of TSRCBitmap;
   WaterItemsCount:integer;
   BeachItems:array of TSRCBitmap;
   BeachItemsCount:integer;
   Obtacles:array of TSRCObtacle;
   ObtaclesCount:integer;
   Mpalette:TDPalette;
   tmpdata:array of array of byte;
   tmpob:TSRCObtacle;
   collbitmap:PBitmap;
   constructor create;
   destructor destroy;override;
   procedure savetostream(strm:PStream);
   procedure loadfromstream(strm:Pstream);
   Procedure LoadSRCBitmap(SRCB:TBitmaps;kind:byte);
   Procedure LoadSRCColors(kind:byte);
   Procedure SaveCollectionBitmapToStream(strm:PStream);
   function getCollBitmap:PBitmap;
   procedure LoadColor(kind,id:byte;createnew:boolean=true);
   procedure RemoveSpriteAtPos(x,y:smallint);
   procedure ShowSpriteToEditorAtPos(pixX,pixY:integer);
   function CalcIdenticalBitmaps(tbm:Tbitmaps):integer;
   procedure generateObtacle(w,h:integer);
   procedure PlaceSpriteToObtacleByPos(posX,posY,id:integer);

   procedure PlaceSpriteToObtacleByPix(pixX,pixY,id:integer);
   procedure RemoveSpriteFromObtacle(pixX,pixY:integer);
   procedure moveTmpObtacle(dx,dy:integer);
   procedure saveTmpObtacleToTileset;
   function getTmpOBtacleBitmap(withpasscheck:boolean=false):PBitmap;
   function SaveTMPObtacleBitmapToStream(strm:PStream;withpasscheck:boolean=false):boolean;
   function getTmpObtaclePass(pixX,pixY:integer):byte;
end;
type TBMGSpriteBase=class
   items:array of TBMGSpriteCollection;
   current:TBMGSpriteCollection;
   count:integer;
   constructor create;
   destructor destroy;override;
   procedure savetofile;
   procedure loadfromfile(fname:string);
   procedure NamesToListView(LV:PControl);
   procedure SelectCollFromListView(LV:Pcontrol);
   procedure Add(item:TBMGSpriteCollection=nil);
   procedure LookForIdenticalSprites(LV:Pcontrol=nil);
end;
procedure SrcBitmap2Stream(bm:TSRCBitmap;strm:Pstream);
procedure SRCObtacle2Stream(obt:TSRCObtacle;strm:Pstream);
function Stream2SrcBitmap(strm:Pstream):TSRCBitmap;
function Stream2SRCObtacle(strm:Pstream):TSRCObtacle;

var SpriteBases:TBMGSpriteBase;
procedure copy(cfrom:TSRCObtacle;var cto:TSRCObtacle);overload;
implementation
uses BMGSpriteGenerator,MapGeneratorMain;
procedure copy(cfrom:TSRCObtacle;var cto:TSRCObtacle);overload;
var f:Pstream;
begin
f:=NewMemoryStream;
srcObtacle2Stream(cfrom,f);
f.Position:=0;
cto:=Stream2SrcObtacle(f);
f.free;
end;
function Stream2SRCObtacle(strm:Pstream):TSRCObtacle;
var f1,f2:integer;
var x,y:integer;
var b:byte;
var ok:boolean;
begin
      strm.Read(b,1);result.width:=b;
      strm.Read(b,1);result.height:=b;
  setlength(result.PassMask,result.width,result.height);
   for f1:=0 to result.width-1 do
      for f2:=0 to result.height-1 do
         result.PassMask[f1,f2]:=5;
    strm.Read(result.itemcount,sizeof(result.itemcount));
   setlength(result.items,result.itemcount+1);
   setlength(result.itemPos,result.itemcount+1);
   for f1:=0 to result.itemcount do begin
      strm.Read(result.items[f1].data,4096);
      strm.Read(result.items[f1].pass,1);
   end;
   for f1:=0 to result.itemcount do begin
      strm.Read(b,1); result.itemPos[f1].X:=b;
      strm.Read(b,1);result.itemPos[f1].Y:= b;

       x:=result.itemPos[f1].x;
       y:=result.itemPos[f1].y;
       if (x>=0)and(y>=0)and(x<result.width)and(y<result.height)then
          result.PassMask[x,y]:=result.items[f1].pass;
   end;
repeat
ok:=true;x:=-1;
for f1:=0 to result.itemcount do begin
   for f2:=f1+1 to result.itemcount do begin
      if equal(result.itemPos[f1],result.itemPos[f2])then x:=f1;
   end;
end;
if x>=0 then begin
   ok:=false;
   for f1:=x to result.itemcount-1 do begin
      result.items[f1]:=result.items[f1+1];
      result.itempos[f1]:=result.itempos[f1+1];
   end;
   setlength(result.items,result.itemcount);
   setlength(result.itempos,result.itemcount);
   dec(result.itemcount);
end;
until ok;
end;
procedure SRCObtacle2Stream(obt:TSRCObtacle;strm:Pstream);
var f1:integer; 
var b:byte;
begin
      b:=obt.width;strm.Write(b,1);
      b:=obt.height;strm.Write(b,1);
 strm.Write(obt.itemcount,sizeof(obt.itemcount));
   for f1:=0 to obt.itemcount do begin
      strm.Write(obt.items[f1].data,4096);
      strm.Write(obt.items[f1].pass,1);
   end;
   for f1:=0 to obt.itemcount do begin
      b:=obt.itemPos[f1].X;strm.Write(b,1);
      b:=obt.itemPos[f1].Y;strm.Write(b,1);
      end;

end;
function Stream2SrcBitmap(strm:Pstream):TSRCBitmap;
var f1:integer;
begin
result.colcount:=-1;
setlength(result.colID,0);
setlength(result.colQty,0);

strm.Read(result.kind,1);
strm.Read(result.pass,1);

if result.kind=1 then strm.Read(result.Bitmap.data,4096)
          else begin
   strm.Read(result.colcount,sizeof(result.colcount));
   setlength(result.colID,result.colcount+1);
   setlength(result.colQty,result.colcount+1);
   for f1:=0 to result.colcount do begin
      strm.Read(result.colID[f1],1);
      strm.Read(result.colQty[f1],1);
   end;
          end;
end;

procedure SrcBitmap2Stream(bm:TSRCBitmap;strm:Pstream);
var f1:integer;
begin
strm.Write(bm.kind,1);
strm.Write(bm.pass,1);

if bm.kind=1 then strm.Write(bm.Bitmap.data,4096)
          else begin
   bm.colcount:=high(bm.colID);
   strm.Write(bm.colcount,sizeof(bm.colcount));
   for f1:=0 to bm.colcount do begin
      strm.write(bm.colID[f1],1);
      strm.Write(bm.colQty[f1],1);
   end;
          end;
end;

function TBMGSpriteCollection.CalcIdenticalBitmaps(tbm: Tbitmaps): integer;
var f1,f2,f3,f4:integer;
begin
result:=0;
for f1:=0 to landitemscount do
  if landitems[f1].kind=1 then
begin
   f4:=0;
   for f2:=0 to 63 do
      for f3:=0 to 63 do
         if landitems[f1].Bitmap.data[f2,f3]<>tbm.data[f2,f3] then f4:=1;
   if f4=0 then result:=result+1;
end;
for f1:=0 to wateritemscount do
  if wateritems[f1].kind=1 then
begin
   f4:=0;
   for f2:=0 to 63 do
      for f3:=0 to 63 do
         if wateritems[f1].Bitmap.data[f2,f3]<>tbm.data[f2,f3] then f4:=1;
   if f4=0 then result:=result+1;
end;
for f1:=0 to beachitemscount do
  if beachitems[f1].kind=1 then
begin
   f4:=0;
   for f2:=0 to 63 do
      for f3:=0 to 63 do
         if beachitems[f1].Bitmap.data[f2,f3]<>tbm.data[f2,f3] then f4:=1;
   if f4=0 then result:=result+1;
end;

end;

constructor TBMGSpriteCollection.create;
begin
   tmpob.itemcount:=-1;
   tmpob.width:=0;
   tmpob.height:=0;
   setlength(tmpdata,0,0);
   setlength(LandItems,0);
   LandItemsCount:=-1;
   setlength(WaterItems,0);
   WaterItemsCount:=-1;
   setlength(BeachItems,0);
   BeachItemsCount:=-1;
   setlength(Obtacles,0);
   ObtaclesCount:=-1;
   collbitmap:=nil;

end;

destructor TBMGSpriteCollection.destroy;
var f1:integer;
begin
   setlength(tmpdata,0,0);tmpdata:=nil;
   LandItemsCount:=high(LandItems);
   for f1:=0 to LandItemsCount do begin
      setlength(LandItems[f1].colID,0);
      setlength(LandItems[f1].colQTY,0);
   end;
   setlength(LandItems,0);
   WaterItemsCount:=high(WaterItems);
   for f1:=0 to WaterItemsCount do begin
      setlength(WaterItems[f1].colID,0);
      setlength(WaterItems[f1].colQTY,0);
   end;
   setlength(WaterItems,0);
   BeachItemsCount:=high(BeachItems);
   for f1:=0 to BeachItemsCount do begin
      setlength(BeachItems[f1].colID,0);
      setlength(BeachItems[f1].colQTY,0);
   end;
   setlength(BeachItems,0);
   ObtaclesCount:=high(Obtacles);
   for f1:=0 to ObtaclesCount do begin
      setlength(Obtacles[f1].PassMask,0,0);
      setlength(Obtacles[f1].items,0);
      setlength(Obtacles[f1].itemPos,0);
   end;
   setlength(Obtacles,0);
   if collbitmap<>nil then collbitmap.Free;
   collbitmap:=nil;
   generateObtacle(0,0);
   inherited;
end;
procedure TBMGSpriteCollection.generateObtacle(w, h: integer);
begin
tmpob.width:=w;
tmpob.height:=h;
setlength(tmpob.PassMask,w+1,h+1);
tmpob.itemcount:=-1;
setlength(tmpob.items,0);
setlength(tmpob.itemPos,0);
end;

function TBMGSpriteCollection.getCollBitmap: PBitmap;
var stream:Pstream;
begin
if collbitmap<>nil then begin result:=collbitmap;exit;end;

collbitmap:=NewBitmap(1,1);
stream:=NewMemoryStream;
SaveCollectionBitmapToStream(stream);
stream.Position:=0;
collbitmap.LoadFromStream(stream);
stream.Free;
result:=collbitmap;
end;

function TBMGSpriteCollection.getTmpOBtacleBitmap(withpasscheck:boolean=false): PBitmap;
var stream:Pstream;
begin
result:=NewBitmap(1,1);
stream:=NewMemoryStream;
if SaveTMPObtacleBitmapToStream(stream,withpasscheck)=false then begin
   stream.free;
   result.Free;
   result:=nil;
   exit;
end;
stream.Position:=0;
result.LoadFromStream(stream);
stream.Free;
end;

function TBMGSpriteCollection.getTmpObtaclePass(pixX, pixY:integer): byte;
var tpos:TXY;
var f1:integer;
begin
tpos:=XY(trunc(pixX / 64),trunc(pixY / 64));
result:=5;
for f1:=0 to tmpob.itemcount do begin
   if equal(tmpob.itemPos[f1],tpos) then result:=tmpob.items[f1].pass;
end;
end;

procedure TBMGSpriteCollection.LoadColor(kind, id: byte;createnew:boolean);

begin
if id=0 then exit;
if collbitmap<>nil then begin collbitmap.free;collbitmap:=nil;end;

if kind=0 then begin
  if createnew then begin
   LandItemsCount:=high(LandItems)+1;
   setlength(LandItems,LandItemsCount+1);
   LandItems[LandItemsCount].colcount:=1;
   setlength(LandItems[LandItemsCount].colID,2);
   setlength(LandItems[LandItemsCount].colQTY,2);
      LandItems[LandItemsCount].colID[0]:=0;
      LandItems[LandItemsCount].colQty[0]:=1;
   end else begin
    inc(LandItems[LandItemsCount].colcount);
      setlength(LandItems[LandItemsCount].colID,LandItems[LandItemsCount].colcount+1);
      setlength(LandItems[LandItemsCount].colQTY,LandItems[LandItemsCount].colcount+1);
   end;
      LandItems[LandItemsCount].colID[LandItems[LandItemsCount].colcount]:=id;
      LandItems[LandItemsCount].colQty[LandItems[LandItemsCount].colcount]:=4000;
   LandItems[LandItemsCount].kind:=2;
   LandItems[LandItemsCount].pass:=kind;
end;
if kind=1 then begin
  if createnew then begin
   WaterItemsCount:=high(WaterItems)+1;
   setlength(WaterItems,WaterItemsCount+1);
   WaterItems[WaterItemsCount].colcount:=1;
   setlength(WaterItems[WaterItemsCount].colID,2);
   setlength(WaterItems[WaterItemsCount].colQTY,2);
      WaterItems[WaterItemsCount].colID[0]:=0;
      WaterItems[WaterItemsCount].colQty[0]:=1;
   end else begin
   inc(WaterItems[WaterItemsCount].colcount);
   setlength(WaterItems[WaterItemsCount].colID,WaterItems[WaterItemsCount].colcount+1);
   setlength(WaterItems[WaterItemsCount].colQTY,WaterItems[WaterItemsCount].colcount+1);
   end;
      WaterItems[WaterItemsCount].colID[WaterItems[WaterItemsCount].colcount]:=ID;
      WaterItems[WaterItemsCount].colQty[WaterItems[WaterItemsCount].colcount]:=4000;
   WaterItems[WaterItemsCount].kind:=2;
   WaterItems[WaterItemsCount].pass:=kind;
end;
if kind=2 then begin
  if createnew then begin
   BeachItemsCount:=high(BeachItems)+1;
   setlength(BeachItems,BeachItemsCount+1);
   BeachItems[BeachItemsCount].colcount:=1;
   setlength(BeachItems[BeachItemsCount].colID,2);
   setlength(BeachItems[BeachItemsCount].colQTY,2);
      BeachItems[BeachItemsCount].colID[0]:=0;
      BeachItems[BeachItemsCount].colQty[0]:=1;
   end else begin
   inc(BeachItems[BeachItemsCount].colcount);
   setlength(BeachItems[BeachItemsCount].colID,BeachItems[BeachItemsCount].colcount+1);
   setlength(BeachItems[BeachItemsCount].colQTY,BeachItems[BeachItemsCount].colcount+1);
   end;
      BeachItems[BeachItemsCount].colID[BeachItems[BeachItemsCount].colcount]:=ID;
      BeachItems[BeachItemsCount].colQty[BeachItems[BeachItemsCount].colcount]:=4000;
   BeachItems[BeachItemsCount].kind:=2;
   BeachItems[BeachItemsCount].pass:=kind;
end;
end;

procedure TBMGSpriteCollection.loadfromstream(strm: Pstream);
var f1:integer;
begin
   name:=strm.ReadStrZ;
   strm.Read(LandItemsCount,sizeof(LandItemsCount));
   setlength(LandItems,LandItemsCount+1);
   for f1:=0 to LandItemsCount do LandItems[f1]:=Stream2SrcBitmap(strm);

   strm.Read(WaterItemsCount,sizeof(WaterItemsCount));
   setlength(WaterItems,WaterItemsCount+1);
   for f1:=0 to WaterItemsCount do WaterItems[f1]:=Stream2SrcBitmap(strm);

   strm.Read(BeachItemsCount,sizeof(BeachItemsCount));
   setlength(BeachItems,BeachItemsCount+1);
   for f1:=0 to BeachItemsCount do BeachItems[f1]:=Stream2SrcBitmap(strm);

   strm.Read(ObtaclesCount,sizeof(ObtaclesCount));
   setlength(Obtacles,ObtaclesCount+1);
   for f1:=0 to ObtaclesCount do Obtacles[f1]:=Stream2SrcObtacle(strm);

   strm.Read(Mpalette,sizeof(MPalette));

end;

procedure TBMGSpriteCollection.LoadSRCBitmap(SRCB: TBitmaps; kind: byte);
begin

if kind=0 then begin
   LandItemsCount:=high(LandItems)+1;
   setlength(LandItems,LandItemsCount+1);
   setlength(LandItems[LandItemsCount].colID,0);
   setlength(LandItems[LandItemsCount].colQTY,0);
   LandItems[LandItemsCount].Bitmap:=SRCB;
   LandItems[LandItemsCount].kind:=1;
   LandItems[LandItemsCount].pass:=kind;
end;
if kind=1 then begin
   WaterItemsCount:=high(WaterItems)+1;
   setlength(WaterItems,WaterItemsCount+1);
   setlength(WaterItems[WaterItemsCount].colID,0);
   setlength(WaterItems[WaterItemsCount].colQTY,0);
   WaterItems[WaterItemsCount].Bitmap:=SRCB;
   WaterItems[WaterItemsCount].kind:=1;
   WaterItems[WaterItemsCount].pass:=kind;
end;
if kind=2 then begin
   BeachItemsCount:=high(BeachItems)+1;
   setlength(BeachItems,BeachItemsCount+1);
   setlength(BeachItems[BeachItemsCount].colID,0);
   setlength(BeachItems[BeachItemsCount].colQTY,0);
   BeachItems[BeachItemsCount].Bitmap:=SRCB;
   BeachItems[BeachItemsCount].kind:=1;
   BeachItems[BeachItemsCount].pass:=kind;
end;
if collbitmap<>nil then begin collbitmap.free;collbitmap:=nil;end;
end;

procedure TBMGSpriteCollection.LoadSRCColors(kind: byte);
var f1:integer;
begin

if collbitmap<>nil then begin collbitmap.free;collbitmap:=nil;end;
if kind=0 then begin
   LandItemsCount:=high(LandItems)+1;
   setlength(LandItems,LandItemsCount+1);
   LandItems[LandItemsCount].colcount:=generator.colorcount;
   setlength(LandItems[LandItemsCount].colID,LandItems[LandItemsCount].colcount+1);
   setlength(LandItems[LandItemsCount].colQTY,LandItems[LandItemsCount].colcount+1);
   for f1:=0 to LandItems[LandItemsCount].colcount do begin
      LandItems[LandItemsCount].colID[f1]:=generator.colorID[f1];
      LandItems[LandItemsCount].colQty[f1]:=generator.colorQTY[f1];
   end;
   LandItems[LandItemsCount].kind:=2;
   LandItems[LandItemsCount].pass:=kind;
end;
if kind=1 then begin
   WaterItemsCount:=high(WaterItems)+1;
   setlength(WaterItems,WaterItemsCount+1);
   WaterItems[WaterItemsCount].colcount:=generator.colorcount;
   setlength(WaterItems[WaterItemsCount].colID,WaterItems[WaterItemsCount].colcount+1);
   setlength(WaterItems[WaterItemsCount].colQTY,WaterItems[WaterItemsCount].colcount+1);
   for f1:=0 to WaterItems[WaterItemsCount].colcount do begin
      WaterItems[WaterItemsCount].colID[f1]:=generator.colorID[f1];
      WaterItems[WaterItemsCount].colQty[f1]:=generator.colorQTY[f1];
   end;
   WaterItems[WaterItemsCount].kind:=2;
   WaterItems[WaterItemsCount].pass:=kind;
end;
if kind=2 then begin
   BeachItemsCount:=high(BeachItems)+1;
   setlength(BeachItems,BeachItemsCount+1);
   BeachItems[BeachItemsCount].colcount:=generator.colorcount;
   setlength(BeachItems[BeachItemsCount].colID,BeachItems[BeachItemsCount].colcount+1);
   setlength(BeachItems[BeachItemsCount].colQTY,BeachItems[BeachItemsCount].colcount+1);
   for f1:=0 to BeachItems[BeachItemsCount].colcount do begin
      BeachItems[BeachItemsCount].colID[f1]:=generator.colorID[f1];
      BeachItems[BeachItemsCount].colQty[f1]:=generator.colorQTY[f1];
   end;
   BeachItems[BeachItemsCount].kind:=2;
   BeachItems[BeachItemsCount].pass:=kind;
end;
end;

procedure TBMGSpriteCollection.moveTmpObtacle(dx, dy: integer);
var f1:integer;
begin
for f1:=0 to tmpob.itemcount do begin
   tmpob.itemPos[f1]:=xy(tmpob.itemPos[f1].x+dx,tmpob.itemPos[f1].y+dy);
end;
end;

procedure TBMGSpriteCollection.PlaceSpriteToObtacleByPix(pixX, pixY,
  id: integer);
var tpos:TXY;
var f1,f2:integer;
begin
if maxmap.loaded=false then exit;
if id>maxmap.Data.mapitemscount then exit;
if id<0 then exit;
tpos:=XY(trunc(pixX / 64),trunc(pixY / 64));
f2:=-1;
for f1:=0 to tmpob.itemcount do begin
   if equal(tmpob.itemPos[f1],tpos) then f2:=f1;
end;
if f2=-1 then begin
  inc(tmpob.itemcount);
  setlength(tmpob.itemPos,tmpob.itemcount+1);
  setlength(tmpob.items,tmpob.itemcount+1);
  f2:=tmpob.itemcount;
end;
tmpob.itemPos[f2]:=tpos;
tmpob.items[f2]:=maxmap.Data.bitmaps[id];
end;

procedure TBMGSpriteCollection.PlaceSpriteToObtacleByPos(posX, posY,
  id: integer);
var tpos:TXY;
var f1,f2:integer;
begin
if maxmap.loaded=false then exit;
if id>maxmap.Data.mapitemscount then exit;
if id<0 then exit;
tpos:=XY(posx,posy);
f2:=-1;
for f1:=0 to tmpob.itemcount do begin
   if equal(tmpob.itemPos[f1],tpos) then f2:=f1;
end;
if f2=-1 then begin
  inc(tmpob.itemcount);
  setlength(tmpob.itemPos,tmpob.itemcount+1);
  setlength(tmpob.items,tmpob.itemcount+1);
  f2:=tmpob.itemcount;
end;
tmpob.itemPos[f2]:=tpos;
tmpob.items[f2]:=maxmap.Data.bitmaps[id];
end;

procedure TBMGSpriteCollection.RemoveSpriteAtPos(x, y: smallint);
var w,h,f1,f2,f3:integer;
begin
if x<0 then exit;if y<0 then exit;
if collbitmap<>nil then begin collbitmap.free;collbitmap:=nil;end;
f3:=LandItemsCount;
if f3<WaterItemsCount then f3:=WaterItemsCount;
if f3<BeachItemsCount then f3:=BeachItemsCount;
if f3>=0 then h:=(f3+1)*(64+1) else h:=0;
w:=3*(64+1);
if y<=h then begin
   if x>w then exit;
   if x<64 then begin
      f2:=trunc(y / (64+1));
      if f2<=LandItemsCount then begin
         for f1:=f2 to LandItemsCount-1 do begin
            landitems[f1]:=landitems[f1+1];
         end;
         setlength(landitems,LandItemsCount);
         LandItemsCount:=high(landitems);
      end;
      exit;
   end;
   if x<(64+64+1) then begin
      f2:=trunc(y / (64+1));
      if f2<=WaterItemsCount then begin
         for f1:=f2 to WaterItemsCount-1 do begin
            Wateritems[f1]:=Wateritems[f1+1];
         end;
         setlength(Wateritems,WaterItemsCount);
         WaterItemsCount:=high(Wateritems);
      end;
      exit;
   end;

      f2:=trunc(y / (64+1));
      if f2<=BeachItemsCount then begin
         for f1:=f2 to BeachItemsCount-1 do begin
            Beachitems[f1]:=Beachitems[f1+1];
         end;
         setlength(Beachitems,BeachItemsCount);
         BeachItemsCount:=high(Beachitems);
      end;
   exit;
end;

h:=h+2;
for f3:=0 to obtaclescount do begin
   if (h<y)and(y<(h+(obtacles[f3].height*(64+1)))) then begin
      setlength(Obtacles[f3].PassMask,0,0);
      setlength(Obtacles[f3].items,0);
      setlength(Obtacles[f3].itemPos,0);
      for f1:=f3 to obtaclescount-1 do begin
         obtacles[f1]:=obtacles[f1+1];
      end;
      setlength(obtacles,obtaclescount);
      obtaclescount:=high(obtacles);
   exit;
   end;
   h:=h+(obtacles[f3].height*(64+1))+2;
end;
end;

procedure TBMGSpriteCollection.RemoveSpriteFromObtacle(pixX,
  pixY: integer);
var tpos:TXY;
var f1,f2:integer;
begin
tpos:=XY(trunc(pixX / 64),trunc(pixY / 64));
f2:=-1;
for f1:=0 to tmpob.itemcount do begin
   if equal(tmpob.itemPos[f1],tpos) then f2:=f1;
end;
if f2>=0 then begin
  for f1:=f2 to tmpob.itemcount-1 do begin
     tmpob.itemPos[f1]:=tmpob.itemPos[f1+1];
     tmpob.items[f1]:=tmpob.items[f1+1];
  end;
  setlength(tmpob.itemPos,tmpob.itemcount);
  setlength(tmpob.items,tmpob.itemcount);
  dec(tmpob.itemcount);

end;
end;

procedure TBMGSpriteCollection.SaveCollectionBitmapToStream(strm: PStream);
var w,h,f1,f2,f3,f4,ph,x,y:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;
begin
f3:=LandItemsCount;
if f3<WaterItemsCount then f3:=WaterItemsCount;
if f3<BeachItemsCount then f3:=BeachItemsCount;
if f3>=0 then h:=(f3+1)*(64+1) else h:=0;
w:=3*(64+1);
ph:=h;
h:=h+1;
for f1:=0 to ObtaclesCount do begin
   h:=h+(obtacles[f1].height*(64+1+2));
   if w<(obtacles[f1].width*(64+1)) then w:=(obtacles[f1].width*(64+1));
end;
w:=(((w+1) div 4)*4)-1;
setlength(tmpdata,w+1,h+1);
for f1:=0 to w do for f2:=0 to h do tmpdata[f1,f2]:=0;
if f3>=0 then begin
   for f3:=0 to landitemscount do begin
      if landitems[f3].kind=1 then begin
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1,f2+(f3*(64+1))]:=landitems[f3].Bitmap.data[f2,f1];
      end else begin
          generator.load(landitems[f3]);
          generator.randomizespr;
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1,f2+(f3*(64+1))]:=generator.tmpout.data[f1,f2];
      end;
   end;
   for f3:=0 to wateritemscount do begin
      if wateritems[f3].kind=1 then begin
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1+(64+1),f2+(f3*(64+1))]:=wateritems[f3].Bitmap.data[f2,f1];
      end else begin
          generator.load(wateritems[f3]);
          generator.randomizespr;
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1+(64+1),f2+(f3*(64+1))]:=generator.tmpout.data[f1,f2];
      end;
   end;
   for f3:=0 to beachitemscount do begin
      if beachitems[f3].kind=1 then begin
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1+(64+64+2),f2+(f3*(64+1))]:=beachitems[f3].Bitmap.data[f2,f1];
      end else begin
          generator.load(beachitems[f3]);
          generator.randomizespr;
        for f1:=0 to 63 do
          for f2:=0 to 63 do
            tmpdata[f1+(64+64+2),f2+(f3*(64+1))]:=generator.tmpout.data[f1,f2];
      end;
   end;
end;
for f3:=0 to obtaclescount do begin

if ph<0 then ph:=0;
if ph>0 then ph:=ph+2;
for f1:=0 to obtacles[f3].itemcount do begin
   for f2:=0 to 63 do
      for f4:=0 to 63 do begin
        x:=(obtacles[f3].itemPos[f1].X*(64+1))+f2;
        y:=(obtacles[f3].itemPos[f1].Y*(64+1))+f4+ph;
        if (x>=0)and(y>=0)and(x<w)and(y<h)then
        tmpdata[x,y]:=obtacles[f3].items[f1].data[f4,f2];
      end;
end;
   ph:=ph+(obtacles[f3].height*(64+1))+2;

end;

bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h)+1078;
bh.i.Widt:=w;bh.i.Heig:=h;
bh.i.SizI:=(w*h);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=Mpalette;
strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h) downto 0 do begin
   for f1:=0 to (w) do begin
      csh[cshpz]:=tmpdata[f1,f2];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
end;
if cshpz>0 then strm.write(csh,cshpz+1);
setlength(tmpdata,0,0);
tmpdata:=nil;

end;

function TBMGSpriteCollection.SaveTMPObtacleBitmapToStream(strm: PStream;withpasscheck:boolean=false):boolean;
var w,h,f1,f2,f3,x,y:integer;
var bh:bmHeader;
var csh:array [0..249]of byte;
var cshpz:byte;
begin
result:=false;
w:=tmpob.width*64;
h:=tmpob.height*64;
if (w=0)or(h=0)then exit;
result:=true;
setlength(tmpdata,w,h);
for f1:=0 to w-1 do
  for f2:=0 to h-1 do
    tmpdata[f1,f2]:=0;
for f1:=0 to w-1 do
   for f2:=0 to tmpob.height-1 do begin
      tmpdata[f1,f2*64]:=1;
   end;
for f1:=0 to tmpob.width-1 do
   for f2:=0 to h-1 do begin
      tmpdata[f1*64,f2]:=1;
   end;

for f1:=0 to tmpob.itemcount do begin
   for f2:=0 to 63 do
      for f3:=0 to 63 do begin
        x:=(tmpob.itemPos[f1].X*64)+f2;
        y:=(tmpob.itemPos[f1].Y*64)+f3;
        if (x>=0)and(y>=0)and(x<w)and(y<h)then
        tmpdata[x,y]:=tmpob.items[f1].data[f3,f2];
      end;
   if withpasscheck then begin
   for f2:=0 to 63 do begin
      x:=(tmpob.itemPos[f1].X*64);
      y:=(tmpob.itemPos[f1].Y*64)+f2;
      tmpdata[x,y]:=tmpob.items[f1].pass+1;
      tmpdata[x+63,y]:=tmpob.items[f1].pass+1;
      tmpdata[x+2,y]:=tmpob.items[f1].pass+1;
      tmpdata[x+61,y]:=tmpob.items[f1].pass+1;
      x:=(tmpob.itemPos[f1].X*64)+f2;
      y:=(tmpob.itemPos[f1].Y*64);
      tmpdata[x,y+2]:=tmpob.items[f1].pass+1;
      tmpdata[x,y+61]:=tmpob.items[f1].pass+1;
      tmpdata[x,y]:=tmpob.items[f1].pass+1;
      tmpdata[x,y+63]:=tmpob.items[f1].pass+1;
   end;
   end;
end;
bh.f.Typf:=ord('B')+(ord('M')*256);bh.f.Res1:=0;bh.f.Res2:=0;bh.f.OfBm:=1078;
bh.i.Size:=40;bh.i.Plan:=1;bh.i.BitC:=8;bh.i.Comp:=0;
bh.f.Size:=(w*h)+1078;
bh.i.Widt:=w;bh.i.Heig:=h;
bh.i.SizI:=(w*h);
bh.i.XppM:=0;bh.i.YppM:=0;
bh.i.NCoL:=256;bh.i.NCoI:=256;
bh.p:=Mpalette;
bh.p[0].color:=clGray;
bh.p[1].color:=clGreen;
bh.p[2].color:=clRed;
bh.p[3].color:=clMaroon;
bh.p[4].color:=clBlue;

strm.Write(bh.f.Typf,2);strm.Write(bh.f.Size,4);strm.Write(bh.f.Res1,2);strm.Write(bh.f.Res2,2);strm.Write(bh.f.OfBm,4);
strm.Write(bh.i.Size,4);strm.Write(bh.i.Widt,4);strm.Write(bh.i.Heig,4);strm.Write(bh.i.Plan,2);strm.Write(bh.i.BitC,2);strm.Write(bh.i.Comp,4);strm.Write(bh.i.SizI,4);strm.Write(bh.i.XppM,4);strm.Write(bh.i.YppM,4);strm.Write(bh.i.NCoL,4);strm.Write(bh.i.NCoI,4);
strm.Write(bh.p,1024);
cshpz:=0;
for f2:=(h-1) downto 0 do
   for f1:=0 to (w-1) do begin
      csh[cshpz]:=tmpdata[f1,f2];inc(cshpz);
      if cshpz>249 then begin
         cshpz:=0;
         strm.write(csh,250);
      end;
   end;
if cshpz>0 then strm.write(csh,cshpz+1);
setlength(tmpdata,0,0);
tmpdata:=nil;

end;

procedure TBMGSpriteCollection.saveTmpObtacleToTileset;
var f1,f2,x,y:integer;
begin
if collbitmap<>nil then begin collbitmap.free;collbitmap:=nil;end;
setlength(tmpob.PassMask,tmpob.width,tmpob.height);
for f1:=0 to tmpob.width-1 do
   for f2:=0 to tmpob.height-1 do
      tmpob.passmask[f1,f2]:=5;
for f1:=0 to tmpob.itemcount do begin
   x:=tmpob.itempos[f1].X;
   y:=tmpob.itempos[f1].Y;
   if (x>=0)and(y>=0)and(x<tmpob.width)and(y<tmpob.height)then
      tmpob.passmask[x,y]:=tmpob.items[f1].pass;
end;
   inc(ObtaclesCount);
   setlength(Obtacles,ObtaclesCount+1);
   x:=ObtaclesCount;
   Obtacles[x].width:=tmpob.width;
   Obtacles[x].height:=tmpob.height;
   setlength(Obtacles[x].PassMask,Obtacles[x].width,Obtacles[x].height);
      for f1:=0 to Obtacles[x].width-1 do
         for f2:=0 to Obtacles[x].height-1 do
            Obtacles[x].passmask[f1,f2]:=tmpob.passmask[f1,f2];
   Obtacles[x].itemcount:=tmpob.itemcount;
   setlength(Obtacles[x].items,Obtacles[x].itemcount+1);
   setlength(Obtacles[x].itemPos,Obtacles[x].itemcount+1);
   for f1:=0 to Obtacles[x].itemcount do begin
      Obtacles[x].items[f1]:=tmpob.items[f1];
      Obtacles[x].itemPos[f1]:=tmpob.itemPos[f1];
   end;

end;

procedure TBMGSpriteCollection.savetostream(strm: PStream);
var f1:integer;
begin
   strm.WriteStrZ(name);
   LandItemsCount:=high(LandItems);
   strm.Write(LandItemsCount,sizeof(LandItemsCount));
   for f1:=0 to LandItemsCount do SrcBitmap2Stream(LandItems[f1],strm);

   WaterItemsCount:=high(WaterItems);
   strm.Write(WaterItemsCount,sizeof(WaterItemsCount));
   for f1:=0 to WaterItemsCount do SrcBitmap2Stream(WaterItems[f1],strm);

   BeachItemsCount:=high(BeachItems);
   strm.Write(BeachItemsCount,sizeof(BeachItemsCount));
   for f1:=0 to BeachItemsCount do SrcBitmap2Stream(BeachItems[f1],strm);

   ObtaclesCount:=high(Obtacles);
   strm.Write(ObtaclesCount,sizeof(ObtaclesCount));
   for f1:=0 to ObtaclesCount do SrcObtacle2Stream(Obtacles[f1],strm);

   strm.Write(Mpalette,sizeof(MPalette));

end;

procedure TBMGSpriteCollection.ShowSpriteToEditorAtPos(pixX,
  pixY: integer);
var h,f3:integer; 
begin
if pixx<0 then exit;if pixy<0 then exit;

f3:=LandItemsCount;
if f3<WaterItemsCount then f3:=WaterItemsCount;
if f3<BeachItemsCount then f3:=BeachItemsCount;
if f3>=0 then h:=(f3+1)*(64+1) else h:=0;

if pixy<=h then begin
   exit;
end;

h:=h+2;
for f3:=0 to obtaclescount do begin
   if (h<pixy)and(pixy<(h+(obtacles[f3].height*(64+1)))) then begin
      generateObtacle(0,0);
      copy(obtacles[f3],tmpob);
   exit;
   end;
   h:=h+(obtacles[f3].height*(64+1))+2;
end;
end;

procedure TBMGSpriteBase.Add(item: TBMGSpriteCollection);
begin
count:=high(items)+1;
setlength(items,count+1);
if item=nil then items[count]:=TBMGSpriteCollection.create else items[count]:=item;
current:=items[count];
current.name:='Tileset #'+int2str(count);
end;

constructor TBMGSpriteBase.create;
var ss:string;
    sprfiles:pDirList;
    f1:integer;
begin
  current:=nil;
  setlength(items,0);
  count:=-1;
  ss:=getstartdir;
  sprfiles:=NewDirList(ss,'*.res',FILE_ATTRIBUTE_NORMAL);

   if sprfiles.Count>0 then
     for f1:=0 to sprfiles.count-1 do loadfromfile(ss+sprfiles.names[f1]);
if sprfiles<>nil then begin
   sprfiles.Free;

end;
end;

destructor TBMGSpriteBase.destroy;
var f1:integer;
begin

for f1:=0 to high(items)do
   if items[f1]<>nil then begin
      items[f1].Free;
      items[f1]:=nil;
   end;
setlength(items,0);
count:=-1;
  inherited;
end;

procedure TBMGSpriteBase.loadfromfile(fname: string);
var F:Pstream;
var f1,cnt:integer;
var ss:string;
begin
   if not(fileexists(fname))then exit;
   f:=NewReadFileStream(Fname);
   ss:=f.ReadStrZ;
   if ss<>'BMapGeneratorTileset' then exit;
   f.Read(cnt,sizeof(cnt));

   for f1:=0 to cnt do begin
   inc(count);setlength(items,count+1);
      items[count]:=TBMGSpriteCollection.create;
      items[count].loadfromstream(f);
      items[count].filename:=Fname;
   end;

   if count>=0 then current:=items[0];
   f.Free;
end;

procedure TBMGSpriteBase.LookForIdenticalSprites(LV: Pcontrol);

var tlv:PControl;
var t:TBMGSpriteCollection;
var f1,f2,f3,f4:integer;
begin
if lv=nil then tlv:=NewListView(nil,lvsDetailNoHeader, [ ], nil, nil, nil ) else tlv:=lv;
lv.Clear;
lv.LVColAdd('SpriteCollections',taLeft,200);
for f1:=0 to count do begin
   t:=items[f1];
   for f2:=0 to t.LandItemsCount do begin
      for f3:=0 to count do begin f4:=0;
         if f3<>f1 then
            if t.LandItems[f2].kind=1 then f4:=items[f3].CalcIdenticalBitmaps(t.LandItems[f2].Bitmap);
         if f4<>0 then tlv.LVItemAdd(items[f1].name+' Land #'+int2str(f2)+' = '+items[f3].name+' '+int2str(f4)+' times');
      end;
   end;
end;
for f1:=0 to count do begin
   t:=items[f1];
   for f2:=0 to t.WaterItemsCount do begin
      for f3:=0 to count do begin f4:=0;
         if f3<>f1 then
            if t.WaterItems[f2].kind=1 then f4:=items[f3].CalcIdenticalBitmaps(t.WaterItems[f2].Bitmap);
         if f4<>0 then tlv.LVItemAdd(items[f1].name+' Water #'+int2str(f2)+' = '+items[f3].name+' '+int2str(f4)+' times');
      end;
   end;
end;
for f1:=0 to count do begin
   t:=items[f1];
   for f2:=0 to t.BeachItemsCount do begin
      for f3:=0 to count do begin f4:=0;
         if f3<>f1 then
            if t.BeachItems[f2].kind=1 then f4:=items[f3].CalcIdenticalBitmaps(t.BeachItems[f2].Bitmap);
         if f4<>0 then tlv.LVItemAdd(items[f1].name+' Beach #'+int2str(f2)+' = '+items[f3].name+' '+int2str(f4)+' times');
      end;
   end;
end;
if lv=nil then tlv.Free;
end;

procedure TBMGSpriteBase.NamesToListView(LV: PControl);
var f1:integer;
begin
lv.Clear;
lv.LVColAdd('SpriteCollections',taLeft,200);
for f1:=0 to count do begin
   lv.LVItemAdd(items[f1].name);
end;
if count<0 then lv.LVItemAdd('  ');
end;

procedure TBMGSpriteBase.savetofile;

var f1,f2,f3:integer;
var ss:string;
var files:array of Pstream;
var fnames:array of string;
var fc:array of integer;
var fcount:integer;
begin
fcount:=-1;setlength(files,fcount+1);setlength(fnames,fcount+1);setlength(fc,fcount+1);

   count:=high(items);
   if count>=0 then begin
      inc(fcount);setlength(files,fcount+1);setlength(fnames,fcount+1);setlength(fc,fcount+1);
      files[fcount]:=NewMemoryStream;fnames[fcount]:=items[0].filename;fc[0]:=0;
      for f1:=1 to count do begin
         f3:=0;
         for f2:=0 to fcount do begin
            if items[f1].filename=fnames[f2] then begin f3:=1;end;
         end;
         if f3=0 then begin
            inc(fcount);setlength(files,fcount+1);setlength(fnames,fcount+1);setlength(fc,fcount+1);
            files[fcount]:=NewMemoryStream;fnames[fcount]:=items[f1].filename;fc[fcount]:=0;
         end;
      end;
   end;
   for f1:=0 to count do
     for f2:=0 to fcount do
        if items[f1].filename=fnames[f2] then inc(fc[f2]);
   for f2:=0 to fcount do dec(fc[f2]);
   ss:='BMapGeneratorTileset';
   for f1:=0 to fcount do begin
      files[f1].WriteStrZ(ss);
      files[f1].Write(fc[f1],sizeof(fc[f1]));
   end;
   count:=high(items);
   for f1:=0 to count do begin
      for f2:=0 to fcount do begin
         if fnames[f2]=items[f1].filename then
            items[f1].savetostream(files[f2]);
      end;
   end;
   for f1:=0 to fcount do begin
      files[f1].SaveToFile(fnames[f1],0,files[f1].Position);
      files[f1].Free;
      setlength(fnames[f1],0);
   end;
fcount:=-1;setlength(files,fcount+1);setlength(fnames,fcount+1);setlength(fc,fcount+1);

end;

procedure TBMGSpriteBase.SelectCollFromListView(LV: Pcontrol);
var f1:integer;
begin
   for f1:=0 to count do begin
      if items[f1].name=LV.LVItems[lv.LVCurItem,0] then current:=items[f1];
      if generator<>nil then generator.mpalette:=current.Mpalette;
   end;
   if current=nil then begin
      if count>=0 then current:=items[0];
   end;
end;

Initialization
SpriteBases:=nil;
finalization
if SpriteBases<>nil then SpriteBases.Free;
SpriteBases:=nil;
end.

