unit BMaxGGameMap;

interface
uses windows,kol,BMGMaxMap,BMaxGTypes,BProcsPack,BMaxGUnitsInfo,BMaxGObject;
type PGameMapCell=^TGameMapCell;
   TGameMapCell=object(TObj)
   terr:terrtpes;
   selfpos:TXY;
   maxpass:byte;
   Units:array of PObj;
   Unitscount:integer;
   curUid:integer;
   resource:TResourcePoint;
   procedure setmaxpass(mpass:byte);
   procedure placeunit(unt:PMaxGoldObject);
   function getselected:PMaxGoldObject;
   function terrtype:terrtpes;
   procedure selectnext;
   function getnext:Pobj;
   destructor destroy;virtual;
   procedure drawUnits;
   function UnitsIn:Theader;
   procedure removeunit(unt:PMaxGoldObject);
   function click(button:integer):integer;
   private
   function findfreeUpos:integer;
end;
type PGameMap=^TGameMap;
   TGameMap=object(TObj)
   Cells:array of array of PGameMapCell;
   resources:array of TRmap;
   rcount:integer;
   drawobj:array of PObj;
   mask,smask:Pmask;
   maxmap:PMaxMap;
   mapsz:TXY;
   destructor destroy;virtual;
   procedure useSectors(S:array of TStartSector;sc:integer;pl:word;sec:byte);
   procedure setmaxmap(NewMaxMap:PMaxMap);
   procedure generatemaskfor(canmove:TMoveCost);
   function positionfree(pos:TXY;unt:PUnitUpgradeHistory):boolean;
   procedure placeunit(pos:TXY;unt:PMaxGoldObject);
   procedure placeresources(startAtpos:TXY);
   procedure drawUnits;
   procedure removeunit(unt:PMaxGoldObject);
   function cell(pos:TXY):PGameMapCell;
   function click(pos:TXY;button:integer):integer;
   private
   procedure compileRMap;
   procedure clearDrawObj;
end;
Function NewGameMap:PGameMap;
Function NewGameMapCell:PGameMapCell;
implementation
Uses BMaxGDraw;
Function NewGameMapCell:PGameMapCell;
begin
   new(result,create);
   result.Unitscount:=-1;
   result.curUid:=-1;
   setlength(result.Units,0);
end;

Function NewGameMap:PGameMap;
begin
   new(result,create);
   result.Cells:=nil;
   result.resources:=nil;
   result.rcount:=-1;
   result.maxmap:=nil;
   result.mask:=nil;
   result.smask:=nil;
end;

function TGameMap.cell(pos: TXY): PGameMapCell;
begin
result:=nil;
 if pos.x>=0 then
  if pos.y>=0 then
   if pos.x<maxmap.mapsize.x then
    if pos.Y<maxmap.mapsize.y then
     result:=cells[pos.x,pos.y];
end;

procedure TGameMap.clearDrawObj;
var f1:integer;
begin
for f1:=0 to high(drawObj) do drawobj[f1]:=nil;
setlength(drawobj,0);
end;

function TGameMap.click(pos: TXY;button:integer):integer;
begin
result:=0;
 if pos.x>=0 then
  if pos.y>=0 then
   if pos.x<maxmap.mapsize.x then
    if pos.Y<maxmap.mapsize.y then
     result:=cells[pos.x,pos.y].click(button);
end;

procedure TGameMap.compileRMap;
var f1,f2,f3:integer;
var ps:TXY;
var tcl:PGameMapCell;
begin
for f1:=0 to rcount do begin
   for f2:=0 to 2 do
     for f3:=0 to 2 do begin
        ps.x:=resources[f1].pos.x+f2;
        ps.y:=resources[f1].pos.y+f3;
        if resources[f1].res[f2,f3].qty>0 then begin
           tcl:=cell(ps);
           if tcl<>nil then tcl.resource:=resources[f1].res[f2,f3];
        end;
     end;
end;
end;

destructor TGameMap.destroy;
var f1,f2:integer;
begin
   cleardrawobj;
   setlength(resources,0);
   rcount:=-1;
   for f1:=0 to mapsz.X-1 do
     for f2:=0 to mapsz.Y-1 do
       free_and_nil(cells[f1,f2]);
   setlength(cells,0,0);cells:=nil;
   maxmap:=nil;
   if smask<>nil then smask.Free;smask:=nil;
   if mask<>nil then mask.Free;mask:=nil;
inherited;
end;

procedure TGameMap.drawUnits;
var f1,f2:integer;
begin

cleardrawobj;
setlength(DrawObj,3);
drawobj[0]:=Glsr[IDMdraw];
for f1:=0 to mapsz.X-1 do
   for f2:=0 to mapsz.Y-1 do
      cells[f1,f2].drawunits;
end;

procedure TGameMap.generatemaskfor(canmove: TMoveCost);
var f1,f2:integer;
var canpass:byte;
begin
if smask<>nil
   then mask.load(smask,makerect(0,0,mapsz.X-1,mapsz.y-1))
   else mask.load(0,makerect(0,0,mapsz.X-1,mapsz.y-1));
if assigned(canmove) then begin
for f1:=0 to mapsz.X-1 do
   for f2:=0 to mapsz.Y-1 do
   if smask.p[f1,f2]=0 then begin
      if canmove(cells[f1,f2].terrtype)>0 then canpass:=0 else canpass:=2;
       mask.p[f1,f2]:=canpass;
   end;
end;
end;

procedure TGameMap.placeresources(startAtpos: TXY);
begin

inc(rcount);setlength(resources,rcount+1);
resources[rcount]:=largeRAW;
resources[rcount].pos:=xy(startAtPos.x-1,startAtPos.y-1);
compileRMap;
end;

procedure TGameMap.placeunit(pos: TXY; unt: PMaxGoldObject);
var f1:integer;
begin
for f1:=1 to unt.allinfo.info.size.size do
   cells[pos.x+unt.allinfo.info.size.pos[f1].X,pos.y+unt.allinfo.info.size.pos[f1].y].placeunit(unt);
end;

function TGameMap.positionfree(pos: TXY;
  unt: PUnitUpgradeHistory): boolean;
var f1:integer;
var tps:TXY;
var tc:PGameMapCell;
begin
result:=true;
for f1:=1 to unt.info.size.size do begin
   tps.x:=pos.x+unt.info.size.pos[f1].x;
   tps.y:=pos.y+unt.info.size.pos[f1].y;
   tc:=cell(tps);
   if tc<>nil then begin
      if unt.info.canmove(tc.terrtype)<0 then result:=false;
     if (smask<>nil) then
         if smask.p[tps.x,tps.y]>0 then result:=false;
   end;
end;
end;

procedure TGameMap.removeunit(unt: PMaxGoldObject);
var f1,f2:integer;

begin
for f1:=0 to maxmap.mapsize.x-1 do
  for f2:=0 to maxmap.mapsize.y-1 do
  cells[f1,f2].removeunit(unt);

end;

procedure TGameMap.setmaxmap(NewMaxMap: PMaxMap);
var f1,f2:integer;
begin
maxmap:=newmaxmap;
mapsz.x:=maxmap.mapsize.x;
mapsz.y:=maxmap.mapsize.y;
setlength(cells,mapsz.X,mapsz.Y);
for f1:=0 to mapsz.x-1 do
  for f2:=0 to mapsz.Y-1 do begin
     cells[f1,f2]:=NewGameMapCell;
     cells[f1,f2].setmaxpass(maxmap.getmaxpass(f1,f2));
     cells[f1,f2].selfpos:=XY(f1,f2);
  end;
end;

procedure TGameMap.useSectors(S: array of TStartSector; sc: integer;
  pl: word; sec: byte);
  var f1,f2,f3:integer;
  var scl:single;
begin
   if sec=0 then exit;
   smask:=newmask(maxmap.mapsize.x,maxmap.mapsize.y);
   scl:=maxmap.mapsize.x / sec;
   for f1:=0 to (maxmap.mapsize.x-1) do begin
      for f2:=0 to (maxmap.mapsize.y-1) do begin
         smask.p[f1,f2]:=1;
         for f3:=0 to sc do
           if (s[f3].x=trunc(f1 / scl))and(s[f3].y=trunc(f2/scl))then
             if (s[f3].player=pl) then smask.p[f1,f2]:=0;
      end;
   end;
   mask:=newmask(maxmap.mapsize.x,maxmap.mapsize.y);
   mask.load(smask,makerect(0,0,maxmap.mapsize.x-1,maxmap.mapsize.y-1));

end;

function TGameMapCell.click(button: integer):integer;
var f1:integer;

begin
result:=0;
if unitscount>=0 then begin
  glsr[IDMapCell]:=@self;
  for f1:=0 to unitscount do
     if units[f1]<>nil then begin
        PMaxGoldObject(units[f1]).click(button);
        if PMaxGoldObject(units[f1]).player=glsr[IDCurplayer] then result:=result+1 else result:=result-1;
     end;
end;
end;

destructor TGameMapCell.destroy;
var f1:integer;
begin
Unitscount:=high(units);
for f1:=0 to unitscount do units[f1]:=nil;
setlength(units,0);
units:=nil;
inherited;
end;

procedure TGameMapCell.drawUnits;
var f1:integer;
var gmap:PGameMap;
begin
gmap:=PGameMap(Glsr[IDGamemap]);
if unitscount<0 then exit;
gmap.drawobj[1]:=@self;
for f1:=0 to unitscount do
    if units[f1]<>nil then begin
       gmap.drawobj[2]:=units[f1];
       PMaxGoldObject(units[f1]).allinfo.info.draw(gmap.drawobj);
    end;
end;

function TGameMapCell.findfreeUpos: integer;
var f1:integer;
begin
Unitscount:=high(units);
result:=unitscount+1;
for f1:=0 to unitscount do
 if units[f1]=nil then result:=f1;
if result>unitscount then begin
 setlength(units,result+1);
 Unitscount:=result;
end;
end;

function TGameMapCell.getnext: Pobj;
var f1:integer;
begin
f1:=0;result:=nil;
if UnitsCount<0 then exit;
repeat
f1:=f1+1;
curUid:=curUid+1;
if curUid=-1 then curUid:=0;
if curUid>Unitscount then curUid:=0;
until (units[curUid]<>nil)or(f1>(unitscount*2));
if units[curUid]=nil then exit;
result:=units[curUid];
end;

function TGameMapCell.getselected: PMaxGoldObject;
var f1:integer;
begin
result:=nil;
for f1:=0 to unitscount do
  if units[f1]<>nil then
    if PMaxGoldObject(units[f1]).selected then result:=PMaxGoldObject(units[f1]);
end;

procedure TGameMapCell.placeunit(unt: PMaxGoldObject);
begin
units[findfreeUpos]:=Unt;
end;

procedure TGameMapCell.removeunit(unt: PMaxGoldObject);
var f1:integer;
begin
for f1:=0 to unitscount do if PMaxGoldObject(units[f1])=unt then units[f1]:=nil;
end;

procedure TGameMapCell.selectnext;
var tu:PMaxGoldObject;
begin
tu:=PMaxGoldObject(getnext);
if tu<>nil then tu.selected:=true;
end;

procedure TGameMapCell.setmaxpass(mpass: byte);
begin
   maxpass:=mpass;

   if mpass=1 then terr:=moveterr(1,0,0,0,0,0,0);
   if mpass=2 then terr:=moveterr(0,1,0,0,0,0,0);
   if mpass=0 then terr:=moveterr(0,0,1,0,0,0,0);
   if mpass=3 then terr:=moveterr(0,0,0,1,0,0,0);
end;

function TGameMapCell.terrtype: terrtpes;
var f1:integer;
begin
result:=terr;
for f1:=0 to unitscount do
 if units[f1]<>nil then
   result:=PMaxGoldObject(Units[f1]).Allinfo.info.obtacle(result);
end;

function TGameMapCell.UnitsIn: Theader;
var f1:integer;
var tmg:PMaxGoldObject;
begin
for f1:=1 to 5 do result[f1]:=0;
for f1:=0 to unitscount do
   if units[f1]<>nil then begin
      tmg:=PMaxGoldObject(units[f1]);
         if tmg.player=glsr[IDCurPlayer] then result[1]:=result[1]+1 else result[2]:=result[2]+1;
   end;
end;

end.
