unit BMaxGObject;

interface
uses windows,BMaxGTypes,kol,BMaxGUnitsInfo,BProcsPack;
type PMaxGoldObject=^TMaxGoldObject;
   TMaxGoldObject=object(TObj)
   id:longword;
   selected:boolean;
   pos:TXY;
   player:PObj;
   params:Tcurparams;
   options:TUoptions;
   Maxvalues:TunitParams;
   Allinfo:PUnitUpgradeHistory;
   func:MaxFuncArray;
   procedure Click(Button:Integer);
   destructor destroy;virtual;
   function here(ps:Txy):boolean;
   procedure save2stream(strm:Pstream;fullsave:boolean=true);
   procedure loadfromstream(strm:Pstream);
end;

type PUnits=^TPlayersUnits;
   TPlayersUnits=object(TObj)
   id:longword;
   unitcount:integer;
   units:array of PMaxGoldObject;
   function createUnitForPlayer(Player:PObj;pos:TXY;PUnt:PUnitUpgradeHistory):PMaxGoldObject;
   procedure DestroyUnitForPlayer(Player:PObj;Unt:PMaxGoldObject);
   procedure removeunit(unt:PMaxGoldObject);
   procedure addUnit(unt:PMaxGoldObject);
   function find(byENGName:String):PMaxGoldObject;overload;
   function find(byID:Integer):PMaxGoldObject;overload;
   procedure deselectALL;
   destructor destroy;virtual;
   procedure clear(safe:boolean=false);
   procedure unfragment;
   procedure setdefaultprocs;
   procedure save2stream(strm:Pstream;fullsave:boolean=true);
   procedure loadfromstream(strm:Pstream;fulload:boolean=true);
   private
   function findfreeUnitID:integer;
end;
Function NewUnits:PUnits;
Function NewUnit:PMaxGoldObject;
implementation
uses BmaxGPlayer,BMaxGGame,BmaxGGameMap;
Function NewUnit:PMaxGoldObject;
begin
   new(result,create);
   result.player:=nil;
   result.selected:=false;
   setlength(result.func.procs,0);
   result.func.count:=-1;
   result.player:=nil;
   result.Allinfo:=nil;
end;
Function NewUnits:PUnits;
begin
   new(result,create);
   result.unitcount:=-1;

   result.Id:=0;
   result.units:=nil;
end;

procedure TPlayersUnits.addUnit(unt: PMaxGoldObject);
var f1:integer;
begin
f1:=findfreeunitid;
units[f1]:=Unt;
end;

procedure TPlayersUnits.clear(safe: boolean);
var f1:integer;
begin
   unitcount:=high(units);
   for f1:=0 to unitcount do begin
      if safe=false then
         if units[f1]<>nil then units[f1].free;
      units[f1]:=nil;
   end;
   setlength(units,0);
   units:=nil;
end;

procedure TPlayersUnits.DestroyUnitForPlayer(Player: PObj;
  Unt: PMaxGoldObject);
var f1:integer;
var plr:PNewPlayer;
var gmap:PGameMap;

begin
if player=nil then exit;
plr:=PNewPlayer(player);
gmap:=PGameMap(Glsr[IDGameMap]);
for f1:=0 to unitcount do begin
   if units[f1]=unt then begin
      gmap.removeUnit(unt);
      plr.units.removeUnit(unt);
      units[f1].Free;
      units[f1]:=nil;
      unt:=nil;
   end;
end;
end;

function TPlayersUnits.createUnitForPlayer(Player: PObj;pos:TXY;PUnt:PUnitUpgradeHistory): PMaxGoldObject;
var f1:integer;
var ss:string;
var ok:boolean;
var plr:PNewPlayer;
var gmap:PGameMap;

begin
ok:=true;
result:=nil;
if player=nil then exit;
plr:=PNewPlayer(player);

gmap:=PGameMap(Glsr[IDGameMap]);
if gmap.positionfree(pos,punt)=false then exit;
f1:=findfreeunitid;
units[f1]:=NewUnit;
units[f1].id:=self.id;inc(self.id);
units[f1].player:=player;
units[f1].Maxvalues:=punt.Params;
units[f1].Allinfo:=pUnt;
units[f1].params:=punt.Params.maxparams;
units[f1].options:=punt.info.defOptions;
result:=units[f1];
gmap.PlaceUnit(pos,units[f1]);
units[f1].pos:=pos;
plr.units.addUnit(units[f1]);
setfunc(Units[f1].func,FTLeftClickOnMyUnit,GetFunc(Punt.info.deffunc,FTLeftClickOnMyUnit));
ss:='!'+#13#10+
    '   '+int2str(units[f1].id)+#13#10+
    'PlayerID = '+int2str(plr.playerID)+#13#10+
    'Utype = '+int2str(punt.SelfID);
if units[f1].Maxvalues=nil then begin ok:=false;
  ss:=ss+#13#10+'MaxValues (TUnitParams)  !';
end;
if units[f1].Allinfo=nil then begin ok:=false;
  ss:=ss+#13#10+'Allinfo (UnitUpgradeHistory)  !';
end;
if ok = false then showmessage(ss);
end;

procedure TPlayersUnits.deselectALL;
var f1:integer;
begin
for f1:=0 to unitcount do
   if units[f1]<>nil then units[f1].selected:=false; 
end;

destructor TPlayersUnits.destroy;
begin
   clear;
   unitcount:=-1;

   Id:=0;
   inherited;
end;

destructor TMaxGoldObject.destroy;
begin
   player:=nil;
   Maxvalues:=nil;
   Allinfo:=nil;
   EmptyFunc(func);
   inherited;
end;

function TPlayersUnits.findfreeUnitID: integer;
var f1,f2:integer;
begin
unitcount:=high(units);
f2:=unitcount+1;
for f1:=0 to unitcount do begin
   if units[f1]=nil then f2:=f1;
end;
if f2>unitcount then setlength(units,f2+1);
unitcount:=high(units);
result:=f2;
end;

function TMaxGoldObject.here(ps: Txy): boolean;
begin
   result:=equal(pos,ps);
end;

procedure TMaxGoldObject.Click(Button:Integer);
begin

end;

procedure TPlayersUnits.removeunit(unt: PMaxGoldObject);
var f1:integer;
begin
   for f1:=0 to unitcount do if units[f1]=unt then units[f1]:=nil;
end;

procedure TPlayersUnits.unfragment;
var Ok:boolean;
var f1:integer;
begin
   unitcount:=high(units);
   if unitcount<0 then exit;
   repeat
   ok:=true;
   for f1:=0 to unitcount-1 do begin
      if units[f1]=nil then begin
         units[f1]:=units[f1+1];units[f1+1]:=nil;ok:=false;
      end;
   end;
   if units[unitcount]=nil then begin
      setlength(units,unitcount);unitcount:=high(units);ok:=false;
   end;
   until ok;
end;

function TPlayersUnits.find(byENGName: String): PMaxGoldObject;
var f1:integer;
begin
result:=nil;
for f1:=0 to unitcount do begin
   if units[f1]<>nil then begin
      if (units[f1].Allinfo.info.ENGname=byENGName) then begin
         result:=units[f1];
         exit;
      end;
   end;
end;
end;

procedure TPlayersUnits.setdefaultprocs;
var f1:integer;
begin
unitcount:=high(units);
for f1:=0 to unitcount do begin
   if units[f1]<>nil then begin
      copyFunc(units[f1].Allinfo.info.defFunc,units[f1].Func);

   end;
end;
end;

procedure TMaxGoldObject.save2stream(strm: Pstream;fullsave:boolean);
begin
   strm.Write(id,sizeof(id));
   if fullsave then begin
      strm.Write(selected,sizeof(selected));
      XY2Stream(pos,strm);
      strm.Write(PNewPlayer(player).playerID,sizeof(PNewPlayer(player)));
      params2Stream(params,strm);
      options2stream(options,strm);
      strm.Write(allinfo.SelfID,sizeof(allinfo.SelfID));
      strm.Write(maxvalues.mk,sizeof(maxvalues.mk));
      MaxFuncArray2Stream(Func,strm);
   end;
end;

procedure TMaxGoldObject.loadfromstream(strm: Pstream);
var f:byte;
var w:word;
begin
   strm.Read(id,sizeof(id));
   strm.Read(selected,sizeof(selected));
   pos:=Stream2XY(strm);
   strm.Read(f,1);player:=PNewGame(glsr[IDGame]).player(f);
   Stream2params(strm,params);
   options:=stream2options(strm);
   strm.Read(f,1);allinfo:=PNewPlayer(Player).upgradelevel.FindBy(f);
   strm.Read(w,2);maxvalues:=allinfo.Params(w);
   Stream2MaxFuncArray(Func,strm);
end;

procedure TPlayersUnits.save2stream(strm: Pstream;fullsave:boolean);
var f1:integer;
begin
   unfragment;
   strm.Write(unitcount,sizeof(unitcount));
   for f1:=0 to unitcount do begin
      units[f1].save2stream(strm,fullsave);
   end;
end;

procedure TPlayersUnits.loadfromstream(strm: Pstream;fulload:boolean);
var f1:integer;
var unt:PMaxGoldObject;
var d:LongWord;
var game:PnewGame;
begin
clear;
strm.Read(unitcount,sizeof(unitcount));
game:=PnewGame(glsr[IDGame]);
for f1:=0 to unitcount do begin
  if fulload then begin
     unt:=NewUnit;
     unt.loadfromstream(strm);
     addunit(unt);
  end else begin
     strm.read(d,sizeof(d));
     addunit(game.allunit.find(d));
  end;
end;
end;

function TPlayersUnits.find(byID: Integer): PMaxGoldObject;
var f1:integer;
begin
result:=nil;
for f1:=0 to unitcount do begin
   if units[f1]<>nil then begin
      if (units[f1].ID=byID) then begin
         result:=units[f1];
         exit;
      end;
   end;
end;
end;

end.
