unit BMaxGPrg;

interface
uses kol,Main,BMGMaxMap,BMaxGGame,BMaxGTypes,windows,messages,BMaxGPlayer;

type PProgram=^TProgram;
   TProgram=object(TObj)
   form:PForm1;
   Game:PnewGame;
   NewPlayer:PnewPlayer;

   procedure LoadGame(FromFile:string);
   procedure CreateNewGame;
   procedure CreateNewPlayer;
   procedure AddPlayerToGame;
   procedure SelectGameToLoad(from:Pcontrol=nil);
   Procedure ShowForm(WhatForm:string);
   Procedure UpdateForm(WhatForm:string);
   Procedure GetSaveListForm(fromDir:string;PlaceTo:Pcontrol);
   Procedure UpgradeUnitFromListView(ForPlayer:PnewPlayer;ListView:PControl;x,y:integer);
   procedure setstartsector(x,y:word;paintbox:PControl);
   procedure LoadPlayerByListView(LV:PControl);
   procedure UpdateNewPlayer;
   procedure CheckPassword;
   procedure ChangeNewPlayerColor;
   procedure ExitGame;
   procedure FinishUnload;
   destructor destroy;virtual;
end;
Function NewProgram(OnForm:PForm1):PProgram;
var Prg:PProgram;
implementation
uses BMaxGUnitsInfo,BMaxGDraw,BMaxGObject,BProcsPack;
Function NewProgram(OnForm:PForm1):PProgram;
begin
{$IFDEF BMGLOG}log('Function NewProgram(OnForm:PForm1):PProgram;');{$ENDIF}
   new(result,create);
   Glsr[IDprg]:=result;
   result.form:=OnForm;
   result.game:=nil;
   result.NewPlayer:=nil;
end;

procedure TProgram.AddPlayerToGame;
var f1,f2:integer;
begin
{$IFDEF BMGLOG}log('procedure TProgram.AddPlayerToGame;');{$ENDIF}
if game.sectors>0 then begin
   game.landsectorscount:=high(game.landsectors);
   f2:=0;
   for f1:=0 to game.landsectorscount do begin
      if (game.landsectors[f1].player=255) then begin
         f2:=1;
      end;
   end;
   if f2=0 then begin
      showmessage('You need to select at least one land sectors for you landing'+#13#10+
                  '       !');
      exit;
   end;
end;
game.AddPlayer(NewPlayer);
NewPlayer:=nil;
Showform('SelectPlayerToPlay');
end;

procedure TProgram.ChangeNewPlayerColor;
begin
{$IFDEF BMGLOG}log('procedure TProgram.ChangeNewPlayerColor;');{$ENDIF}
 form.colordialog1.Color:=form.panel1.Color;
 if form.ColorDialog1.Execute then begin
    form.panel1.Color:=form.colordialog1.Color;
    updateNewPlayer;
    Game.drawMinimap(form.PaintBox2,true);
 end;
end;

procedure TProgram.CheckPassword;
begin
{$IFDEF BMGLOG}log('procedure TProgram.CheckPassword;');{$ENDIF}
if game.CurPlayer<>nil then begin
   if game.CurPlayer.info.password=form.EditBox9.Text then begin
        if game.CurPlayer.info.condition=0 then
           showform('UnloadPlayerForm');
           showform('GamePlayerForm');
   end else showmessage('Wrong password'+#13#10+' ,   ');
end;

end;

procedure TProgram.CreateNewGame;
begin
{$IFDEF BMGLOG}log('procedure TProgram.CreateNewGame;');{$ENDIF}
   if game=nil then exit;
   game.get(form.editbox1,form.editbox4,form.editbox2,form.editbox3,form.checkbox1,form.editbox5,form.Label14);
   game.show(form.editbox1,form.editbox4,form.editbox2,form.editbox3,form.checkbox1,form.editbox5,form.editbox7);
   if game.gamefilename='' then begin showmessage('Set GameFileName'+#13#10+'  ');exit;end;
   if (game.mapfile='')or(game.map.loaded=false) then begin showmessage('Select MAX map to play first'+#13#10+'  ');exit;end;
   if game.plcount<2 then begin showmessage('In this version you need minimum 2 players to play'+#13#10+'     ');exit;end;
   if game.startgold<0 then game.startgold:=0;
   if game.moraturn<0 then game.moraturn:=0;
   game.SaveToFile;
   form.hideall;
   showform('MainMenu');
end;

procedure TProgram.CreateNewPlayer;
begin
{$IFDEF BMGLOG}log('procedure TProgram.CreateNewPlayer;');{$ENDIF}
if Newplayer<>nil then Newplayer.free;
newPlayer:=CreatePNewPlayer;
NewPlayer.money:=game.startgold;
newPlayer.load('StartPokupki');
end;

destructor TProgram.destroy;
begin
{$IFDEF BMGLOG}log('destructor TProgram.destroy;');{$ENDIF}
   form:=nil;
   if game<>nil then Game.Free;
   Game:=nil;
   inherited;
end;

procedure TProgram.ExitGame;
begin
if game<>nil then game.savetofile;
end;

procedure TProgram.FinishUnload;
var plr:PNewPlayer;
var f1,f2,r,f3:integer;
var ok:boolean;
var unt,unt2:PMaxGoldObject;
begin
{$IFDEF BMGLOG}log('procedure TProgram.FinishUnload;');{$ENDIF}
plr:=PNewPlayer(glsr[IDCurPlayer]);
if plr=nil then exit;
plr.units.unfragment;
if plr.units.unitcount<0 then begin
   showmessage('         ,   '+#13#10+
               'You need to unload at least one of you starting units, to begin the game');
   exit;
end;
f2:=high(plr.Pokupki);
if f2>=0 then begin
   unt:=plr.units.find('Mining Station');
   if unt=nil then unt:=plr.units.units[0];
   r:=1;
   repeat
   ok:=false;
      for f1:=unt.pos.x-r to unt.pos.x+r do
         for f3:=unt.pos.Y-r to unt.pos.Y+r do
           if not(ok) then begin
            unt2:=game.allunit.createunitforplayer(plr,XY(f1,f3),plr.upgradelevel.findby(plr.pokupki[0].utype));
            if unt2<>nil then begin
               setfunc(unt2.func,FTLeftClickOnMyUnit,ppck.SelectUnloadedPokupka);
               unt2.params.gruz:=plr.Pokupki[0].gruz;
               plr.sellpokupka(unt2.Allinfo,0,false,false);
               f2:=high(plr.Pokupki);
               if f2<0 then ok:=true;
            end;
         end;
inc(r);
if r>(game.map.mapsize.x+game.map.mapsize.y) then ok:=true;
   until ok;
   plr.pokupkiToKolListBox(Pcontrol(glsr[IDCtrl]));
end;
   unt:=plr.units.find('Mining Station');
   if unt=nil then unt:=plr.units.units[0];
   game.gamemap.placeresources(unt.pos);
   plr.units.setdefaultprocs;
   showform('GameForm');
   {$IFDEF BMGLOG}log('END procedure TProgram.FinishUnload;');{$ENDIF}
end;

procedure TProgram.GetSaveListForm(fromDir: string; PlaceTo: Pcontrol);
var FileL:pDirList;
var i:integer;
begin
{$IFDEF BMGLOG}log('procedure TProgram.GetSaveListForm(fromDir: string='''+fromdir+'''; PlaceTo: Pcontrol);');{$ENDIF}
FileL := NewDirList(fromDir,'*.sav',FILE_ATTRIBUTE_NORMAL);
 PlaceTo.Clear;
 if FileL.Count > 0 then 
  for i:=0 to FileL.Count-1 do
   PlaceTo.LVItemAdd(FileL.Names[i]);
free_and_nil(FileL);
end;

procedure TProgram.LoadGame(FromFile: string);
begin
{$IFDEF BMGLOG}log('procedure TProgram.LoadGame(FromFile: string='''+fromfile+''');');{$ENDIF}
   if not(fileexists(FromFile)) then begin showmessage('File '+Fromfile+' not found');exit;end;
   if game<>nil then game.free;
   game:=CreatePNewGame;
   if not(game.LoadFromFile(FromFile)) then begin free_and_nil(game);showmessage('Game not loaded, something is wrong'+#13#10+'  ,   ');exit;end;
   form1.HideAll;
   showform('SelectPlayerToPlay');

end;

procedure TProgram.LoadPlayerByListView(LV: PControl);

var ss:string;
begin
{$IFDEF BMGLOG}log('procedure TProgram.LoadPlayerByListView(LV: PControl);');{$ENDIF}
if LV.CurIndex<0 then begin
   if game.playerscount>0 then begin
      showmessage('  '+#13#10+'Select player first');exit;
   end else begin
      ss:=lv.LVItems[0,0];
   end;
end else begin
   ss:=lv.LVItems[LV.CurIndex,0];
end;
if ss<>'' then begin
   Game.loadPlayer(ss);
   if game.CurPlayer<>nil then begin
      showform('EnterPasswordToLoadGame');
   end;
end;
end;

procedure TProgram.SelectGameToLoad(from:Pcontrol=nil);
begin
{$IFDEF BMGLOG}log('procedure TProgram.SelectGameToLoad(from:Pcontrol);');{$ENDIF}
   if from=nil then begin
      form1.OpenSaveDialog1.filter:='MAX Gold save files *.sav|*.sav';
      form1.OpenSaveDialog1.InitialDir:=getstartdir;
      if form1.OpenSaveDialog1.execute=false then exit;
      LoadGame(form1.OpenSaveDialog1.filename);
      exit;
   end;
   if from=form1.ListView1 then begin
      loadgame(getstartdir+form1.ListView1.LvItems[form1.ListView1.CurIndex,0]);
      exit;
   end;
end;

procedure TProgram.setstartsector(x, y: word;paintbox:PControl);
var sx,sy:integer;
var f1:integer;
var sc:single;
begin
{$IFDEF BMGLOG}log('procedure TProgram.setstartsector(x='+int2str(x)+', y='+int2str(y)+': word;paintbox:PControl);');{$ENDIF}
if game.sectors=0 then exit;
sc:=paintbox.width / game.sectors;
sx:=trunc(x / sc);
sy:=trunc(y / sc);
game.landsectorscount:=high(game.landsectors);
for f1:=0 to game.landsectorscount do begin
   if (game.landsectors[f1].x=sx)and(game.landsectors[f1].y=sy) then begin
      if (game.landsectors[f1].player=255) then begin
         game.landsectors[f1].player:=254;
         exit;
      end;
      if (game.landsectors[f1].player=254) then begin
         game.landsectors[f1].player:=255;
         exit;
      end;
      if (game.landsectors[f1].player<254) then begin
         exit;
      end;
   end;
end;
game.landsectorscount:=game.landsectorscount+1;
setlength(game.landsectors,game.landsectorscount+1);
game.landsectors[game.landsectorscount].x:=sx;
game.landsectors[game.landsectorscount].y:=sy;
game.landsectors[game.landsectorscount].player:=255;
free_and_nil(game.mnmpsctrs);
end;

procedure TProgram.ShowForm(WhatForm: string);
begin
{$IFDEF BMGLOG}log('procedure TProgram.ShowForm(WhatForm: string='''+whatform+''');');{$ENDIF}
form.hideall;

if WhatForm='MainMenu' then begin
   form.Groupbox1.Visible:=true;
   form.groupbox1.Height:=127;
   WhatForm:='OptionsForm';
end;
if WhatForm='OptionsForm' then begin
   form.Groupbox14.Visible:=true;
   form.groupbox14.Height:=95;
end;
if WhatForm='NewGameForm' then begin
   form.Groupbox2.Visible:=true;
   form.groupbox2.Height:=177;
   if Game=nil then game:=CreatePNewGame;
   game.show(form.editbox1,form.editbox4,form.editbox2,form.editbox3,form.checkbox1,form.editbox5,form.EditBox7);
end;
if WhatForm='LoadGameForm' then begin
   GetSaveListForm(getstartdir,form.ListView1);
   form.Groupbox3.Visible:=true;
   form.groupbox3.Height:=174;
end;
if WhatForm='SelectPlayerToPlay' then begin
   form.Groupbox4.Visible:=true;
   form.groupbox4.Height:=326;
   game.getStartConditionstoMemo(form.Memo3);
   game.getPlayersConditionstoListView(form.ListView2);
end;
if WhatForm='AddPlayerForm' then begin
   if newplayer=nil then createNewPlayer;
   newplayer.pokupkiToKolMemo(form1.Memo1);
   form.Groupbox5.Visible:=true;
   form.groupbox5.Height:=260;
   game.getStartConditionstoMemo(form.Memo2);
   form.label17.visible:=(game.sectors>0);
   updateNewPlayer;
end;
if WhatForm='PokupkiForm' then begin
   if form.form.width<500 then form.form.width:=500;
   if form.form.Height<450 then form.form.Height:=450;
   form.GroupBox10.Caption:='Info';
   form.Groupbox6.Visible:=true;
   form.groupbox6.Height:=400;
   newplayer.pokupkiToKolListBox(form1.ListBox1);
   form.Label16.Caption:='Credits '+int2str(newplayer.money);
   updateform('FillListUnitsForBuy');
   form.listbox1.Caption:='';form.listbox3.Caption:='';

end;
if WhatForm='EnterPasswordToLoadGame' then begin
   if game.curplayer<>nil then
     if game.CurPlayer.info.password<>'' then begin
       form.label19.caption:=game.curplayer.info.name;
       form.Groupbox12.Visible:=true;
       form.groupbox12.Height:=73;
     end else begin
        if game.CurPlayer.info.condition=0 then
          begin showform('UnloadPlayerForm');exit; end else
          begin showform('GameForm');exit; end;
     end;
end;
if WhatForm='UnloadPlayerForm' then begin
   form.form.windowState:=wsMaximized;
   form.groupbox13.Align:=caClient;
   game.curplayer.pokupkiToKolListBox(form.Listbox4);
   game.prepareToUnloadPlayer;
   form.TrackBar1SbScroll(form.trackbar1,0);
   game.MDraw.setmaxframerate(str2int(wrt(form.editbox10.Text)));
   game.mdraw.useWheelFrom(form.Form);
   game.mdraw.useWheelFrom(form.Listbox4);
   game.mdraw.useMMoveFrom(form.ListBox4);
   game.mdraw.setOutWnd(form.paintbox4);
   form.groupbox13.Visible:=true;
end;
if WhatForm='GameForm' then begin
   if game=nil then exit;
   game.savetofile;
   if game.MDraw=nil then begin
      game.MDraw:=NewMaxDraw;
      game.MDraw.setmaxmap(game.map);
      end;
   game.MDraw.nodrawnow:=true;
   form.form.windowState:=wsMaximized;
   form.groupbox15.Align:=caClient;
   game.mdraw.ReleaseOutWnd;
   game.mdraw.setOutWnd(form.paintbox5);
   game.MDraw.useWheelFrom(form.Panel4);
   game.MDraw.nodrawnow:=false;
   form.groupbox15.Visible:=true;
end;

end;

procedure TProgram.UpdateForm(WhatForm: string);
var tunt:PUnitupgradehistory;
var f1:integer;
begin
{$IFDEF BMGLOG}log('procedure TProgram.UpdateForm(WhatForm: string'''+whatform+''');');{$ENDIF}
if WhatForm='FillListUnitsForBuy' then begin
   form.listbox3.Clear;form.ListBox3.Caption:='';
   newplayer.upgradelevel.NamesToListBox(form.ListBox3,form.CheckBox2.checked,form.CheckBox4.checked,form.CheckBox3.checked,form.CheckBox5.checked);
end;
if WhatForm='ShowUnitForBuy' then begin
   tunt:=newplayer.upgradelevel.FindBy(form.ListBox3.Items[form.ListBox3.CurIndex]);
   form.GroupBox10.Caption:=tunt.info.name+'('+tunt.info.ENGname+')';
   tunt.Params(form.ListView3,[ParamsInfo,UpgradeMode]);
   if tunt.info.ENGname=form.listbox3.caption then 
      if newplayer.addPokupka(Tunt)>=0 then begin
      newplayer.pokupkiToKolListBox(form.ListBox1);
      WhatForm:='ShowUnitForSell';
   end;
   form.Label16.Caption:='Credits '+int2str(newplayer.money);
   form.listbox3.caption:=tunt.info.ENGname;
end;
if WhatForm='ShowUpgradedUnit' then begin
   tunt:=newplayer.upgradelevel.FindBy(form.ListBox2.Items[form.ListBox2.CurIndex]);
   form.GroupBox10.Caption:=tunt.info.name+'('+tunt.info.ENGname+')';
   tunt.Params(form.ListView3,[ParamsInfo,UpgradeMode]);
end;
if WhatForm='ShowUnitForSell' then begin
   for f1:=0 to high(newplayer.pokupki) do
      if newplayer.pokupki[f1].IdinListbox=form.ListBox1.curindex then begin
         tunt:=newplayer.upgradelevel.FindBy(newplayer.pokupki[f1].Utype);
         form.GroupBox10.Caption:=tunt.info.name+'('+tunt.info.ENGname+')';
         form.ListView3.Caption:=int2str(f1);
         tunt.Params(form.ListView3,[ParamsInfo,GruzInfo,PokupkaMode,UpgradeMode]);
         if form.ListBox1.Caption=Tunt.info.ENGname then begin
            newplayer.sellpokupka(Tunt,f1);
            newplayer.pokupkiToKolListBox(form.ListBox1);
         end else form.ListBox1.Caption:=Tunt.info.ENGname;
         form.Label16.Caption:='Credits '+int2str(newplayer.money);
         exit;
      end;
end;

end;

procedure TProgram.UpdateNewPlayer;
begin
{$IFDEF BMGLOG}log('procedure TProgram.UpdateNewPlayer;');{$ENDIF}
if newplayer=nil then exit;
NewPlayer.info.color:=form.Panel1.color;
NewPlayer.info.name:=form.EditBox6.Text;
NewPlayer.info.password:=form.EditBox8.Text;
end;

procedure TProgram.UpgradeUnitFromListView(ForPlayer: PnewPlayer;
  ListView: PControl; x, y: integer);
var row,col:integer;
var l,r,f1,f2:integer;
var tunt:PUnitupgradehistory;
var ss:string;
begin
{$IFDEF BMGLOG}log('procedure TProgram.UpgradeUnitFromListView(ForPlayer: PnewPlayer;ListView: PControl; x, y: integer);');{$ENDIF}
row:=listview.LVItemAtPos(x,y);
l:=0;r:=0;
for col:=0 to listview.LVColCount-1 do begin
   R:=r+listview.LVColWidth[col];
   if (R>x)then if (L<=x)then begin
      ss:=listview.lvitems[row,col];
      if (ss='+') or (ss='-') then begin
         tunt:=ForPlayer.upgradelevel.FindBy(listview.Caption);
         if (listview.LVItems[row,0]=qty)or(listview.LVItems[row,0]=buyMetall)or(listview.LVItems[row,0]=buyFuel) then begin
            f2:=high(forplayer.pokupki);
            if f2>=0 then
            for f1:=0 to f2 do begin
                if forplayer.pokupki[f1].IdinListbox=form.ListBox1.curindex then begin
                   if (listview.LVItems[row,0]=qty) then begin
                      if ss='-' then begin
                         if tunt.info.buyEnable(false,forplayer.pokupki[f1].count) then begin
                            forplayer.pokupki[f1].count:=forplayer.pokupki[f1].count-1;
                            forplayer.money:=forplayer.money+forplayer.pokupki[f1].cost;
                         end;
                      end;
                      if ss='+' then begin
                         if forplayer.money>=forplayer.pokupki[f1].cost then
                         if tunt.info.buyEnable then begin
                            forplayer.pokupki[f1].count:=forplayer.pokupki[f1].count+1;
                            forplayer.money:=forplayer.money-forplayer.pokupki[f1].cost;
                         end;
                      end;
                   end;
                   if (listview.LVItems[row,0]=buyMetall)or(listview.LVItems[row,0]=buyFuel) then begin
                     if ss='-' then begin
                        if listview.LVItems[row,0]=buyMetall then
                        if forplayer.pokupki[f1].gruz.metall>=5 then
                           forplayer.pokupki[f1].gruz.metall:=forplayer.pokupki[f1].gruz.metall-5;
                        if listview.LVItems[row,0]=buyFuel then
                        if forplayer.pokupki[f1].gruz.fuel>=5 then
                           forplayer.pokupki[f1].gruz.fuel:=forplayer.pokupki[f1].gruz.fuel-5;
                           forplayer.money:=forplayer.money+forplayer.pokupki[f1].count;
                     end;
                     if ss='+' then
                     if forplayer.money>=forplayer.pokupki[f1].count then begin
                        if listview.LVItems[row,0]=buyMetall then
                        if forplayer.pokupki[f1].gruz.metall<tunt.info.GruzMAX.metall then
                           forplayer.pokupki[f1].gruz.metall:=forplayer.pokupki[f1].gruz.metall+5;
                        if listview.LVItems[row,0]=buyFuel then
                        if forplayer.pokupki[f1].gruz.fuel<tunt.info.GruzMAX.fuel then
                           forplayer.pokupki[f1].gruz.fuel:=forplayer.pokupki[f1].gruz.fuel+5;
                        forplayer.money:=forplayer.money-forplayer.pokupki[f1].count;
                     end;
                  end;
                end;
            end;
            forplayer.pokupkiToKolListBox(form.ListBox1);
            updateform('ShowUnitForSell');
            exit;
         end;
         tunt.Upgrade(listview.lvitems[row,0],listview.lvitems[row,col],forplayer.money);
         if listview.LVItems[0,0]=qty then
         tunt.Params(listview,[ParamsInfo,GruzInfo,PokupkaMode,UpgradeMode]) else
         tunt.Params(listview,[ParamsInfo,UpgradeMode]);
         newplayer.upgradelevel.UpgradesToListBox(form.ListBox2);

      exit;
      end;
   end;
   L:=R;
end;
end;

end.
